import java.net.* ;
import java.io.* ;

// Collegamenti alla libreria JAR aggiunta al progetto per gestire le stringhe JSON.
import org.json.simple.* ;
import org.json.simple.parser.* ;

public class ClientClock
{
    public static void main( String[] args )
    {
        Socket  socket ;
        
        String  serverAddress   = "localhost" ;     // Indirizzo IP del Server.
        
        int     serverPort      = 6700 ;            // Porta del Server non bloccata da Firewall.
        
        // Prepara la variabile per l'oggetto che leggerà (riceverà) le informazioni dal Server.
        BufferedReader  bufferedReader ;
        
        System.out.println( "\n  CLOCK CLIENT based on JSON" ) ;

        try
        {
            socket = new Socket( serverAddress , serverPort ) ;
            
            System.out.println( "\n  Connessione aperta col server...") ;
            
            // Costruisce il flusso di input dal Server.
            bufferedReader = new BufferedReader( new InputStreamReader( socket.getInputStream() ) ) ;
            
            // Ricava la string JSON contenente la coppia chiave e data/ora attuale.
            String jsonString = bufferedReader.readLine() ;
            
            // Costruise l'interprete della stringa JSON ricevuta e da convertire in oggetto Array Associativo (Map) in Java.
            JSONParser jsonParser = new JSONParser() ;
            
            // Interpreta la stringa ricevuta generando un oggetto Java generico.
            Object object = jsonParser.parse( jsonString ) ;
            
            // Trasforma l'oggetto generico in Array Associativo.
            JSONObject jsonObject = ( JSONObject )object ;

            // Dall'Array Associativo ricaviamo e stampiamo il valore della "data/ora attuale" dalla chiave "now".
            System.out.println( "\n  ...data e ora attuale: "+jsonObject.get("now")+"..." ) ;
            
            // Chiude flusso e connessione.
            bufferedReader.close() ;
            socket.close();
            
                System.out.println("\n  ...connessione chiusa...");
        }
        catch ( Exception e ) { System.err.println( e ) ; }

        System.out.println( "\n  ...Client terminato.") ;
    }
}